/**********************************************************************/
/* Many-Core Architecture Research Project       Arch Lab. TOKYO TECH */
/**********************************************************************/
#include "MClib.h"

#define SIZE (1 << 5)

volatile int array[SIZE*(1 << 8)];

/**********************************************************************/
int main(int argc, char *args[])
{
    int i;
    int id_x, id_y, rank_x, rank_y;
    MC_init(&id_x, &id_y, &rank_x, &rank_y);

    for (i = 0; i < SIZE*32; i++)
        array[i] = (((id_x << 8) | id_y) << 16) | i;

    if (id_x == 1 && id_y == 1) {
        int idx;
        for(idx = 1; idx < rank_x*rank_y; idx++) {
            while((array[(idx + 1)*SIZE - 1] & 0xffff0000) 
                  == 0x1010000);
        }
    }
    else {
        int size = sizeof(int)*SIZE;
        int stride = 4;
        int dst = 0;
        int offset = ((id_y - 1)*rank_x + (id_x - 1))*SIZE;
        setidxy(&dst, 1, 1);
        MC_sleep(10000);
        MC_dma_put(dst, (int*)array + offset, (int*)array + offset,
                   size, stride, stride);
    }
    
    MC_finalize();
    
    return 0;
}
