#include "network.h"

/**********************************************************************/
/**
 * Cmdbuf constructor
 * \param n the number of command buffer
 */
Cmdbuf::Cmdbuf(int n)
{
    _head = 0;
    _tail = 0;
    _num_entry = 0;
    nentry = n;
    buf = new elem_t[nentry];
}

/**********************************************************************/
/**
 * Cmdbuf destructor
 */
Cmdbuf::~Cmdbuf()
{
//    delete [] buf;
}

/**********************************************************************/
/**
 * get the number of command buffer
 * \return the number of command buffer
 */
int Cmdbuf::num_entry()
{
    return _num_entry;
}

/**********************************************************************/
/**
 * check whether the command buffer has one or more commands or not
 * \return 0: there is no command, 1: there are one or more commands
 */
bool Cmdbuf::isempty()
{
    return (_num_entry == 0);
}

/**********************************************************************/
/**
 * check whether the command buffer is full
 * \return 0: not full, 1: full
 */
bool Cmdbuf::isfull()
{
    return (_num_entry == nentry);
}

/**********************************************************************/
/**
 * enqueue a command to the command buffer
 * \param data the command should be stored to the command buffer
 * \return true: succeeded, false: failed
 */
bool Cmdbuf::enq(void *_data)
{
    
    if (isfull()) {
        printf("## Enqueue is failed. Cmdbuf is full.\n");
        return false;
    }
    else {
//        elem_t hoge = *(elem_t*)_data;
        buf[_tail] = *(elem_t*)_data;
        _tail = (_tail == nentry - 1) ? 0 : _tail + 1;
        _num_entry++;
        return true;
    }
}

/**********************************************************************/
/**
 * dequeue the command in the command buffer
 * \return true: succeeded, false: failed
 */
bool Cmdbuf::deq()
{
    if (isempty()) {
        printf("## Dequeue is failed. Cmdbuf is empty.\n");
        return false;
    }
    else {
        _head = (_head == nentry - 1) ? 0: _head + 1;
        _num_entry--;
        return true;
    }
}

/**********************************************************************/
/**
 * get the older command in the command buffer
 * \return cmdbuf_t*: succeeded, NULL: failed
 */
void *Cmdbuf::head()
{
    if (isempty())
        return NULL;
    else
        return &buf[_head];
}
